{Program pro reseni kvadraticke rovnice
 Bude cist z klavesnice koeficienty kvadraticke rovnice a resit je;
 zadame-li a = 0, skonci.
}

program kvr;
uses crt;

procedure ResQR(a, b, c: real; var x, y: real; var re: boolean);
var d: real;
begin
  d := sqr(b) - 4*a*c;   {diskriminant}
  re := (d >= 0);       {do parametrub re ulozime informaci, zda ma rovnice
                        {realne nebo komplexni koreny}
  d := sqrt(abs(d));    { odmocninu z absolutni hodnoty d potrebujeme
                        {v obou pripadech }
  if re then
  begin   {ma-li rovnice dva realne koreny}
    x := (-b - d)/2/a;
    y := (-b + d)/2/a;
  end
  else
  begin
    x := -b/2/a;
    y := d/2/a;
  end;
end;

var a1, b1, c1: real;
    r: boolean;
    x1, x2: real;

begin
     clrscr;  {smazeme si obrazovku}
     writeln('Program pro reseni kvadradickych rovnic');
     writeln('Zadejte koeficienty rovnice a*x^2 + b*x + c = 0');
     writeln('Zadate-li a = 0, program skonci');
     repeat      {nekonecny cyklus, ktery opustime prikazem break}
      write('zadej a: ');
      read (a1);
      if(a1 = 0) then break;  {je-li a = 0, skonci cyklus}
      write('zadej b: ');
      read (b1);
      write('zadej c: ');
      read (c1);
      ResQR(a1, b1, c1, x1, x2, r);
      if r then {jsou-li koreny realne}
       writeln('rovnice ma dva realne koreny: ', x1:10:5,' a ', x2:10:5)
      else
       writeln('rovnice ma dva komplecni koreny: ', x1:10:5,' +-i* ', x2:10:5);
     until false;
     writeln('Uctiva poklona.');
end.

{Poznamky:
 1. reseni kvadraticke rovnice definujeme jako samostatnou proceduru
    - je to prehlednejsi.
 2. Vsimnete si dvou druhu parametru: a, b, c jsou JEN VSTUPNI - to znamena,
    ze pripadna zmena hodnoty parametru v tele funkce se nepromitne do zmeny
    hodnoty skutecneho parametru. Parametry x, y, re jsou VSTUPNI I VYSTUPNI
    - to znamena, ze umoznuji prenest vysledek zpet z procedury. Pred
    specifikaci takovehoto parametru musi byt klicove slovo VAR. Skutecny parametr
    pak musi byt vzdy promenna odpovidajiciho typu.
 2. Parametry, ktere jsou jen vstupni, tedy ktere prenaseji hodnotu do
    procedury, nikoli vsak zpet, se oznacuji jako parametry
    PREDAVANE HODNOTOU. Parametry, ktere mohou prenaset hodnotu i zpet,
    se nazyvaji PARAMETRY PREDAVANE ODKAZEM.
 3. V tele programu jsme pouzili nekonecny cyklus.
    repeat
     ....
    until false;
    Zde totiz potrebujeme
    cyklus s podminkou uprostred: nejdriv precteme a, podivame se,
    zda to neni 0, a pokud je, ukoncime cyklus. Existuji i jina reseni,
    toto je asi nejpohodlnejsi. Prikaz BREAK zpusobi, ze cyklus skonci a
    program prejde na prvni prikaz za nim.
}