{ PREDAVANI UKAZATELE NA FUNKCI JAKO PARAMETRU
 Funkce Integral(a, b, F) spocita obdelnikovym pravidlem
 integral od a do b z funkce F s presnosti radu eps

 Propracovanejsi implementace obdelnikopveho pravidla, priklady 
 pouziti standardnich funkci.
}

Program integrce;

const
    eps = 1e-5;		{ Pozadovana presnost }

type
    fun = function(x: real):real;

{ Tri ruzne integrandy }
function F(x: real): real; far;
begin
 F := x*x*x;
end;

{Standardni funkce treba "obalit" }
function fsin(x: real): real; far;
begin
 fsin := sin(x);
end;

function fcos(x: real): real; far;
begin
 fcos := cos(x);
end;

{ Funkce pocitajici urcity integral }

function Integral(a, b: real; f: fun): real;
var
  h, stS, S, x: real;
const
  HUGE_VAL = 1.7e38;
begin
 h := (b-a)/2.0;            { krok }
 stS := HUGE_VAL;           {Nejaka velka, nepravdepodobna pocatecni hodnota }
 S := (f(a) + f(a+h))*h;     { Prvni priblizeni }
 while abs(stS - S) > eps do { Pordrobneji viz na komentar konci }
 begin
	stS := S;

	S := 0;
        x := a+h/2;
        while x < b do
        begin
          S := S + f(x);
          x := x + h;
        end;
	S := (S*h +stS)/2;
	h := h / 2.0;
 end;
 Integral := S;
end;

begin
 writeln( 'Integraly od 0 do PI z funkci sin a cos: ');
 writeln(Integral(0.0, PI, fsin):10:5);
 writeln('ted to muze trvat dlouho');
 writeln(Integral(0.0, PI, fcos):10:5);
 writeln('Integral z x^3 od 0 do 1:');
 writeln(Integral(0.0, 1.0, F):10:5 );
end.

{

  K integraci podle obdelnikoveho pravidla:
  Interval (a, b) rozdelima na n dilu o delce h = (b-a) / n.
  Integral pak odhadneme souctem h*(f(a+0*h) + f(a+1*h) + f(a+2.h) + ...).

  Jako pocatecni deleni intervalu (a, b) bereme deleni na polovinu,
  tedy s krokem h = (b/a)/2.
  Vypocteme prvni odhad integralu pri tomto deleni, to je (f(a) + f(a+h))*h.
  Vypoctenou hodnotu si zapamatujeme (ulozime do stS) a spocitame novou
  hodnotu s krokem h/2.
  Vypocet konci, jestlize se stara hodnota od nove lisi o mene nez eps.
  Pri vypoctu s polovicnim krokem nepocitame znovu hodnoty f(x)
  integrovane funkce, ktere jsme uz jednou vypocetli. Ty jsou totiz
  v souctu stS. Proto pricteme jen soucet chybejicich hodnot,
  f(a+h/2) + f(a+h/2 + h) + f(a+h/2 + 2h) + ...)
}