{SOUBOR PENTAGO1.PAS}
{program nakresli pravidelny petiuhelnik}
{a po stisknuti klavesy skonci}

program pentagon;

uses graph, crt;

{cesta k ovladaci graficke karty}
{Zde musite doplnit skutecnou cestu na vasem pocitaci
 do adresare, kde je soubor EGAVGA.BGI. Na mem pocitaci to je C:\PB\BGI
 }
const cesta = 'C:\PB\BGI';

type bod = record   {bod ve dvourozmernem prostoru}
   x, y: integer;
   end;

   vrcholy = array[1..5] of bod;   {vrcholy petiuhelnika}

{tato procedura vytvori pravidelny petiuhelnik se stredem s, polomerem
 opsane kruznice r a vypoctene vrcholy zapise do pole v}
procedure VytvorPetiuhelnik(s: bod; r: integer; var p: vrcholy);
var
   b, b1: bod; {pomocny bod}
   sf, cf: real; {sin a cos 72 stupnu}
   i, xx, yy: integer; {parametr cyklu}
begin
   b.x := r;                  
   b.y := 0;                  
   p[1].x := b.x + s.x;               {prvni vrchol: (0, r) + s}
   p[1].y := b.y + s.y;
   sf := sin(72*pi/180); cf := cos(72*pi/180);
   for i:= 2 to 5 do
   begin
     b1.x := round(b.x*cf - b.y*sf);  {kazdy dalsi vrchol pocitame }
     b1.y := round(b.x*sf + b.y*cf);  {z predchoziho otocenim o 72 stupnu}
     b := b1;
     p[i].x := b1.x + s.x;
     p[i].y := b1.y + s.y;
   end;
end;

procedure NakresliPetiuhelnik(var p: vrcholy);
var
  i: integer;
begin
    moveto(p[5].x, p[5].y);            {prejdeme do jednoho z vrcholu}
    for i := 1 to 5 do lineto(p[i].x, p[i].y);
end;                                   {a spojime ostatni}

var
   driver, mode: integer;
   v: vrcholy;                  {bude obsahovat vrcholy petiuhelnika}
   s: bod;
   r: integer;
   c: char;

begin
  clrscr;
  write('zadej stred petiuhelnika v obrazovkovych souradnicich: ');
  read(s.x, s.y);
  write('zadej polomer kruznice opsane: ');
  read(r);
  driver := detect;    {nechame pocitac, aby urcil typ graf. adapteru}
  initgraph(driver, mode, cesta); {inicializace graf. systemu}
  if(driver < 0) then             {test, zda se podaril start graf. systemu}
  begin
     writeln('nepodaril se start grafiky');
     halt
  end;
  VytvorPetiuhelnik(s, r, v);
  NakresliPetiuhelnik(v);
  OutTextXY(10, getmaxy-10, 'stiskni klavesu...'); {vystup textu}
  c := readkey;         {cekame na stisknuti klavesy}
  closegraph;           {ukoncime graf. system}
end.
{Poznamky:
- nezapominejte, ze souradnice na obrazovce se zadavaji
  jako cela cisla, v pixelech
- pocatek, bod (0,0) je v levem hornim rohu obrazovky
- souradnice x roste doprava, y roste dolu
- funkce GETMAXX a getmaxy zjistuji maximalni mozne hodnoty souradnic x a y
- pokud se nepodari start grafickeho systemu, bude v promenne driver
  (v prvnim parametru promenne INITGRAPH) cislo chyby, ktere je zaporne.
  Jinak tam je cislo urcujici graficky adapter, a to je kladne.
- procedura HALT predcasne ukonci program
}