{
 Jednosmerny  seznam (bez zarazky, neobjektova implementace)
 program vytvori jednosmerny seznam, ulozi do nej nekolik cisel,
 vypise jeho obsah a pak ho smaze.

 Typ data: zmenou teto deklarace zmenime typ dat ukladanych v seznamu
 uprvek: ukazatel na prvek seznamu - tato deklarace smi predchazet
 deklaraci typu prvek
 prvek: prvek seznamu = uzitecna data + ukazatel na dalsi prvek seznamu
 seznam: obsahuje pouze ukazatel na prvni prvek ("hlavu") seznamu
}

type
     data = integer;

     uprvek = ^prvek;

     prvek = record
       d: data;
       dalsi: uprvek;
     end;

     seznam = record
        hlava: uprvek;
     end;

procedure vytvor(var S: seznam);
begin {zajisti, ze v prazdnem seznamu bude ukazatel hlava obsahovat nil}
    S.hlava := nil;
end;


procedure vloz(var S: seznam; co: data);
var {vlozi do seznamu na pocatek novy prvek obsahujici data, ulozena v parametru co}
  p: uprvek;
begin
   if maxavail>sizeof(prvek) then begin {test, zda je dost paneti na alokaci noveho prvku}
      new(p);         {vytvorime novy prvek}
      p^.d := co;     {ulozime do nej data}
      p^.dalsi := S.hlava; {zaradime ho do hlavy seznamu}
      S.hlava := p;
   end else begin
      writeln('neni dostatek pameti'); {neni-li pamet, vypiseme zpravu}
      halt;                            {a ukoncime program}
   end
end;

procedure vypis(var S: seznam);
var     {vypise obsah seznamu}
  p: uprvek;
begin
   p := S. hlava;              {ukazatel na prvni prvek}
   while p <> nil do begin     {dokud nejsme na konci}
      writeln(p^.d);           {vypiseme data a posuneme p na dalsi prvek}
      p := p^.dalsi;
   end
end;

procedure vyprazdni(var S: seznam);
var p: uprvek;                 {odstrani ze seznamu vsechny prvky}
begin
  p:= S.hlava;
  while p <> nil do begin      {dokud nejsme na konci}
      p := p^.dalsi;           {presuneme pomocny ukazatel p na dalsi prvek}
      dispose(S.hlava);        {uvolnime prvni prvek}
      S.hlava := p;            {a do ukazatele na prvni prvek ulozime to, co je v p}
  end;
end;

var S: seznam;

begin  {nekolik prikladu pouziti}
  vytvor(S);
  vloz(S, 10);
  vloz(S, 11);
  vloz(S, 12);
  vloz(S, 13);
  vypis(S);
  vyprazdni(S);
end.