{
  Prvni kroky s objekty: definujeme tridu BOD jako zaklad hierarchie
  grafickych objektu, od ni odvodime potomky KRUZNICE a USECKA.

  Definujeme pole ukazatelu na BOD. Protoze potomek muze v objektovem
  programovani vzdy zastoupit predka, alokujeme 10 ruznych objektu
  (stridave bod, usecku, kruznici) a zobrazime je. Program skonci po
  stisku libovolne klavesy.

  PROGRAM NEFUNGUJE - nakresli pouze body (i tam, kde chceme usecky nebo
  kruznice). Viz komentar za programem.

  Navic obsahuje logickou chybu v navrhu hierarchie - usecka ani kruznice
  nejsou zvlastni pripady bodu.
}

uses graph, crt;

const N = 10;

type
  bod = object
    x, y: integer;
    constructor Init(_x, _y: integer);
    procedure zobraz;
    procedure skryj;
    procedure nakresli(barva: integer);
  end;

  kruznice = object(bod)
    r: integer;
    constructor Init(_x, _y, _r: integer);
    procedure nakresli(barva: integer);
  end;

  usecka=object(bod)
   xk, yk: integer;
   constructor Init(_x, _y, _xk, _yk: integer);
   procedure nakresli(barva: integer);
  end;

{******************** metody tridy bod *************************}
constructor bod.Init;
begin
  x := _x; y := _y;
end;

procedure bod.zobraz;
begin
   nakresli(WHITE);
end;

procedure bod.skryj;
begin
   nakresli(BLACK);
end;

procedure bod.nakresli;
begin
    putpixel(x, y, barva)
end;

{******************** metody tridy kruznice *************************}
constructor kruznice.Init;
begin
  inherited Init(_x,_y);
  r := _r;
end;

procedure kruznice.nakresli;
begin
    setcolor(barva);
    Circle(x, y, r);
end;

{******************** metody tridy usecka *************************}
constructor usecka.Init;
begin
  inherited Init(_x,_y);
  xk := _xk; yk := _yk;
end;

procedure usecka.nakresli;
begin
    setcolor(barva);
    line(x, y, xk, yk);
end;

procedure Inic;
var driver, mode: integer;
begin
    driver := detect;
    initgraph(driver, mode, '');
    if(ioresult <> grok) then begin
        writeln('neco je jinak');
        halt;
    end;
end;

type ubod = ^bod;
     ukruh = ^kruznice;
     uusecka = ^usecka;


var pgo: array [1..N] of ubod;
    i: integer;
    ugo: ubod;

const
    xx: integer = 50;
    yy: integer = 50;

begin
    inic;
    for i := 1 to N do begin
        xx := xx + 40;
        yy := yy + 30;
        case i mod 3 of
          0: pgo[i] := new(ubod, Init(xx, yy));
          1: pgo[i] := new(ukruh, Init(xx, yy, 30));
          2: pgo[i] := new(uusecka, Init(xx, yy, xx+10, yy + 10));
        end;
    end;
    for i := 1 to N do
        pgo[i]^.zobraz;
        {pgo[i]^.nakresli(white);}
    readkey;
    closegraph;
end.

{
 Budete-li program krokovat, zjistite, ze prikaz
 pgo[i]^.zobraz;
 zavola metodu BOD.ZOBRAZ a v jejim tele se vzdy vola BOD.NAKRESLI.
 (Prekladac usoudil, ze kdyz metodu NAKRESLI volame v tele jine metody
 tridy BOD, mame na mysli metodu BOD.NAKRESLI.)

 Podobne dopadneme, nahradime-li tento prikaz prikazem
 pgo[i]^.nakresli(white);
 Zde prekladac usoudi, ze kdyz je pgo[i] ukazatel na BOD, jde nam o metodu
 tridy BOD.

 Zde se vsude pouziva tzv. CASNA VAZBA - o volane metode rozhoduje
 jiz prekladac. Aby bylo mozno o volane metode rozhodnout az za behu
 programu, musime pouzit tzv. POZDNI VAZBU, tj. musime metody,
 kterych se to tyka, deklarovat jako VIRTUALNI.

 Priklad viz soubor VIRT2.PAS.
}