{
 Upravena verze programu VIRT2.PAS.
 Usecka ani kruznice nejsou zvlastni pripad bodu. Na druhe strane
 majhi mnoho spolecneho:
 BOD, USECKA i KRUZNICE jsou zvlastni pripady obecnejsiho pojmu
 GRAFICKY OBJEKT. Proto jsme zde definovali tridu (objektovy typ)
 GO a od nej jsme jako potomky odvodili vsechny tri zbyvajici typy.
}

uses graph, crt;

const N = 10;

type
  GO = object
    constructor Init;
    procedure zobraz;
    procedure skryj;
    procedure nakresli(barva: integer); virtual; {virtualni metoda}
  end;

  bod = object(GO)
    x, y: integer;
    constructor Init(_x, _y: integer);
    procedure nakresli(barva: integer); virtual; {virtualni metoda}
  end;


  kruznice = object(GO)
    x, y, r: integer;
    constructor Init(_x, _y, _r: integer);
    procedure nakresli(barva: integer); virtual; {virtualni metoda}
  end;

  usecka=object(GO)
   x, y, xk, yk: integer;
   constructor Init(_x, _y, _xk, _yk: integer);
   procedure nakresli(barva: integer);  virtual; {virtualni metoda}
  end;

{******************** metody tridy GO *************************}
constructor GO.Init;
begin
end;

procedure GO.zobraz;
begin
   nakresli(WHITE);
end;

procedure GO.skryj;
begin
   nakresli(BLACK);
end;

procedure GO.nakresli;
begin
    writeln('chyba - volani GO.nakresli');
    halt;
end;

{******************** metody tridy bod *************************}
constructor bod.Init;
begin
  x := _x; y := _y;
end;

procedure bod.nakresli;
begin
    putpixel(x, y, barva)
end;



{******************** metody tridy kruznice *************************}
constructor kruznice.Init;
begin
  x := _x; y := _y;
  r := _r;
end;

procedure kruznice.nakresli;
begin
    setcolor(barva);
    Circle(x, y, r);
end;

{******************** metody tridy usecka *************************}
constructor usecka.Init;
begin
  x := _x; y := _y;
  xk := _xk; yk := _yk;
end;

procedure usecka.nakresli;
begin
    setcolor(barva);
    line(x, y, xk, yk);
end;

procedure Inic;
var driver, mode: integer;
begin
    driver := detect;
    initgraph(driver, mode, '');
    if(ioresult <> grok) then begin
        writeln('neco je jinak');
        halt;
    end;
end;

type
     ugo = ^go;
     ubod = ^bod;
     ukruh = ^kruznice;
     uusecka = ^usecka;


var pgo: array [1..N] of ugo;
    i: integer;

const
    xx: integer = 50;
    yy: integer = 50;

begin
    inic;
    for i := 1 to N do begin
        xx := xx + 40;
        yy := yy + 30;
        case i mod 3 of
          0: pgo[i] := new(ubod, Init(xx, yy));
          1: pgo[i] := new(ukruh, Init(xx, yy, 30));
          2: pgo[i] := new(uusecka, Init(xx, yy, xx+10, yy + 10));
        end;
    end;
    for i := 1 to N do
        pgo[i]^.zobraz;
        {pgo[i]^.nakresli(white);}
    readkey;
    closegraph;
end.
