unit Graf1;

{ Obsahuje objektov typy Bod, Kruh a Usecka, kter umouj zobrazit svtc
  bod, krunici resp. seku. Kad typ m tyto metody: konstruktor Udelej,
  kter inicializuje atributy, Zobraz, kter nakresl objekt v barv uren
  parametrem, Nakresli a Smaz, kter nakresl objekt ble resp. ern (tj.
  jej smaou). Dle je k disposici destruktor Zrus, kter objekt zru (a
  smae jeho zobrazen) a metody PosunSe a UsadSe, kter umouj pohyb
  objekt po obrazovce.
  Metoda Obnov objekt nakresl, pouze pokud m atrubut "Sviti" hodnotu 1,
  tj. pokud byl objekt ji nakreslen, ale mohl bt pokozen pohybem
  jinho objektu.
  Metoda PosunSe m jeden parametr typu "Pohyb", definovanho v jednotce
  Pomoc. Podle hodnoty parametru pemst objekt na obrazovce, zvt jej
  nebo jej oto.
  Metoda UsadSe umouje najt sprvn msto objektu na obrazovce. te pokyny
  z klvesnice (pouije funkci CtiKlavesy, definovanou v jednotce Pomoc)
  a podle nich vol metodu PosunSe s odpovdajcm parametrem.
  Pokyny z klvesnice:
  kurzorov ipky:  pohyb v udanm smru;
  PgUp/PgDn:        zvten/zmenen
  O:                pootoen o 18 stup
  Enter/Esc:        Usazen objektu na zvolen msto, pejde se ke generovn
                    dalho objektu.
  Je zde tak definovna procedura Instrukce, kter vypisuje dek s
  o pouitelnch klvesch.

! Chcete-li si tento program spustit, muste upravit cestu ke grafickm 
! souborm (BGI), tj. hodnotu konstanty cesta (nebo pekoprovat do aktulnho
! adrese soubor egavga.bgi).

  Pokud chcete zmnit velikost posunu, muste upravit konstantu "oCo"
  definovanou v hlavnm programu. Mete tak snadno pidat dal operace
  s objekty (nap. zmnu barev apod.): sta rozit definici typu "Pohyb"
  a pidat interpretaci odpovdajcch pokyn do metod PosunSe.
}

interface

uses Pomoc, Graph, Crt;

const cesta : string = 'c:\pascal';

procedure Instrukce(text:string);

type
  Bod = object
     constructor Udelej(xx, yy: integer);
     destructor Zrus;
     procedure Zobraz(BARVA: integer);
     procedure Nakresli;
     procedure Smaz;
     procedure Obnov;
     procedure PosunSe(kam: Pohyb; oKolik: integer);
     procedure UsadSe(krok: integer);
    private
      x, y: integer;
      Sviti: byte;
  end;

  Kruh = object
     constructor Udelej(xx, yy, rr: integer);
     destructor Zrus;
     procedure Zobraz(BARVA:integer);
     procedure Nakresli;
     procedure Smaz;
     procedure Obnov;
     procedure PosunSe(kam: Pohyb; oKolik: integer);
     procedure UsadSe(krok: integer);
    private
      xy: Bod;
      r:  integer;
  end;

  Usecka = object
     constructor Udelej(xx, yy:integer);
     destructor Zrus;
     procedure Zobraz(BARVA: integer);
     procedure Nakresli;
     procedure Smaz;
     procedure Obnov;
     procedure PosunSe(kam: Pohyb; oKolik: integer);
     procedure UsadSe(krok: integer);
    private
     xy: Bod;
     polodelka: integer;
     u1, u2: real;
  end;

implementation

var ca, sa: real; {sinus a kosinus hlu otoen}

{ ************************** metody typu Bod *************************** }

constructor Bod.Udelej(xx, yy: integer);  {inicializace objektu}
  begin
    x := xx;
    y := yy;
    Sviti := 0;
  end;

destructor Bod.Zrus;
  begin
     Smaz;
  end;

procedure Bod.Zobraz(Barva: integer);
  begin
    PutPixel(x, y, BARVA);
  end;

procedure Bod.Nakresli;
  begin
    Zobraz(WHITE);
    Sviti := 1;
  end;

procedure Bod.Obnov;
  begin
    if Sviti = 1 then Zobraz(WHITE);
  end;

procedure Bod.Smaz;
  begin
    Zobraz(BLACK);
    Sviti := 0;
  end;


procedure Bod.PosunSe(kam: Pohyb; oKolik: integer);
  begin
     Smaz;
     case kam of
       Vlevo:  x := x-oKolik;
       Vpravo: x := x+oKolik;
       Nahoru: y := y-oKolik;
       Dolu:   y := y+oKolik;
     end;
     Nakresli;
  end;

procedure Bod.UsadSe(krok: integer);
var Pokyn: Pohyb;
begin
    repeat
     Pokyn := CtiKlavesu;
     PosunSe(Pokyn, krok);
    until Pokyn = Konec;
end;

{ ************************** metody typu Kruh *************************** }

constructor Kruh.Udelej(xx, yy, rr: integer);
  begin
   xy.Udelej(xx, yy);
   r := rr;
  end;

destructor Kruh.Zrus;
  begin
     Smaz;
  end;

procedure Kruh.Zobraz(BARVA:integer);
  begin
    SetColor(BARVA);
    Circle(xy.x,xy.y,r);
  end;

procedure Kruh.Nakresli;
  begin
      Zobraz(WHITE);
      xy.Sviti := 1;
  end;

procedure Kruh.Smaz;
  begin
    Zobraz(BLACK);
    xy.Sviti := 0;
  end;

procedure Kruh.Obnov;
  begin
      if xy.Sviti = 1 then Zobraz(WHITE);
  end;

procedure Kruh.PosunSe(kam: Pohyb; oKolik: integer);
  begin
     Smaz;
     case kam of
       Vlevo:  xy.x := xy.x-oKolik;
       Vpravo: xy.x := xy.x+oKolik;
       Nahoru: xy.y := xy.y-oKolik;
       Dolu:   xy.y := xy.y+oKolik;
       Zvetsi: r := r+oKolik;
       Zmensi: r := r-oKolik;
     end;
     if r < 0 then r := 0;
     Nakresli;
  end;

procedure Kruh.UsadSe(krok: integer);
var Pokyn: Pohyb;
begin
    repeat
     Pokyn := CtiKlavesu;
     PosunSe(Pokyn, krok);
    until Pokyn = Konec;
end;

{ ************************** metody typu Usecka *************************** }

constructor Usecka.Udelej(xx, yy: integer);
  begin
   xy.Udelej(xx, yy);
   polodelka := 50;
   u1 := 1.0;
   u2 := 0.0;
  end;

destructor Usecka.Zrus;
  begin
     Smaz;
  end;

procedure Usecka.Zobraz(BARVA:integer);
  var x1, y1, x2, y2: integer;
  begin
    SetColor(BARVA);
    x1 := round(xy.x+u1*polodelka);
    y1 := round(xy.y+u2*polodelka);
    x2 := round(xy.x-u1*polodelka);
    y2 := round(xy.y-u2*polodelka);
    line(x1, y1, x2, y2);
  end;

procedure Usecka.Nakresli;
  begin
      Zobraz(WHITE);
      xy.Sviti := 1;
  end;

procedure Usecka.Smaz;
  begin
    Zobraz(BLACK);
    xy.Sviti := 0;
  end;

procedure Usecka.Obnov;
  begin
      if xy.Sviti = 1 then Zobraz(WHITE);
  end;


procedure Usecka.PosunSe(kam: Pohyb; oKolik: integer);
  var t: real;
  begin
     Smaz;
     case kam of
       Vlevo:  xy.x := xy.x-oKolik;
       Vpravo: xy.x := xy.x+oKolik;
       Nahoru: xy.y := xy.y-oKolik;
       Dolu:   xy.y := xy.y+oKolik;
       Zvetsi: polodelka := polodelka+oKolik;
       Zmensi: polodelka := polodelka-oKolik;
       Otoc:  begin
         t := ca*u1 - sa*u2;
         u2 := sa*u1 + ca*u2;
         u1 := t;
        end;
     end;
     if polodelka < 0 then polodelka := 0;
     Nakresli;
  end;

procedure Usecka.UsadSe(krok: integer);
var Pokyn: Pohyb;
begin
    repeat
     Pokyn := CtiKlavesu;
     PosunSe(Pokyn, krok);
    until Pokyn = Konec;
end;

{ ************************** samostatn procedura ************************** }

procedure Instrukce(text: string);
begin
  Settextstyle(Defaultfont, HorizDir, 1);
  SetViewPort(5, yy-50,xx-5,yy-5, ClipOn);
  ClearViewPort;
  moveto(50,5);
  OutText(text);
  SetViewPort(0, 0, xx, yy, true);
end;

{ ************************** inicializan st ************************** }

begin
 ca := cos(pi/10);
 sa := sin(pi/10);
end.