unit Pomoc;

{ Tato jednotka obsahuje definici tupu "Pohyb" (pkazy pro metody PosunSe)
  deklaraci procedur SpustGrafiku a Ukoncigrafiku a funkce CtiKlavesu.
  Chceme-li zvtit monosti programu, meme pidat dal hodnoty k typu
  "Pohyb", upravit definici funkce Ctiklavesu a upravit metody PosunSe
  v modulu Graf1.
  Funkce Spustgrafiku hled grafick driver v adresi, urenm konstantou
  "cesta" (v modulu Graf1). Pokud jej tam nenajde, pt se na ni uivatele.
  Krom toho inicializuje promnn xx a yy (max. hodnoty souadnic na
  obrazovce).
}

interface

uses Crt, Graph;

var xx, yy: integer;

type Pohyb = (Vlevo, Vpravo, Nahoru, Dolu, Zvetsi, Zmensi, Otoc, Konec);

function CtiKlavesu: Pohyb;
procedure SpustGrafiku(cesta: string);
procedure UkonciGrafiku;

implementation

const Enter = 13;   { kdov sla pouvanch klves }
      Esc   = 27;
      Nula  = 0;
      Up    = 72;
      Down  = 80;
      Left  = 75;
      Right = 77;
      PgUp  = 73;
      PgDn  = 81;
      maleR = 114;
      velkeR= 82;
      maleO = 111;
      velkeO= 79;


function CtiKlavesu: Pohyb;
  var c     : byte;
      Navrat: Boolean;
 begin
  repeat
  Navrat := true;
  c := ord(ReadKey);
  case c of
    Enter, Esc: CtiKlavesu := Konec;
    maleO, velkeO: CtiKlavesu := Otoc;
    Nula : begin
       c := ord(ReadKey);
       case c of
         Up   : CtiKlavesu := Nahoru;
         Down : CtiKlavesu := Dolu;
         Left : CtiKlavesu := Vlevo;
         Right: CtiKlavesu := Vpravo;
         PgUp : CtiKlavesu := Zvetsi;
         PgDn : CtiKlavesu := Zmensi;
         else Navrat := false;
       end;
    end;
    else Navrat := false;
  end;
  until Navrat;
 end;

procedure SpustGrafiku(cesta: string); {start grafickho systmu}
   var Mode: integer;
   const Driver: integer = 0;
  begin
   repeat
   InitGraph(Driver, Mode, cesta);
   if Driver < 0 then
     if Driver = -3 then begin
       write('Neumm najt soubory BGI. Zadej cestu: ');
       Readln(cesta);
       Driver := 0;
     end else begin
       writeln('chyba grafiky: ', Driver);
       Halt(1);
     end;
    until Driver > 0;
    xx := getmaxx;  { max. hodnoty souadnic }
    yy := getmaxy;
  end;

procedure UkonciGrafiku; {Ukonen grafiky}
  begin
    CloseGraph;
  end;

end.