(***********************************************************************
  	PROGRAM.PAS
  prvn verze, s ddinost, ale bez pozdn vazby

  Program podle pokyn z klvesnice vytv dynamick reprezentzace grafickch
  objekt a pohybuje s nimi po obrazovce. Objekt me bt max. 100.
  Adresy objekt jsou ukldny v poli Objekty sloenm ze
  zznam "Ukaz", je obsahuj ukazatele na Bod a informaci o skutenm
  typu objektu.
  V interpretanm cyklu se zjist, jak objekt vytvoit, a pak se pouije
  metody UsadSe, kter jej "usad" na msto, kter mu vybereme.
  Pokyny (viz t npovdu dole na obrazovce pi bhu programu):
  B  -  vytvo se bod;
  K  -  vytvo se krunice;
  U  -  vytvo se seka;
  Q  -  ukonen programu.
  Pi pechodu jednoho objektu pes jin se pokod jeho kresba. Oprav
  ji procedura Obnova, kter se vol po definitivnm usazen objektu.

  Pouit ddinosti pece jen program ve srovnn s minulou verz
  zjednoduilo, ale voln procedur je stle neobratn: Musme si u
  kadho ukazatele poznamenat skuten typ instance, na kterou ukazuje.
  Stle chyb pozdn vazba.
***********************************************************************)


Program GrafickeObjekty;

uses Pomoc, Graf1, Graph, Crt;

type pBod = ^Bod;
     pKruh = ^Kruh;
     pUsecka = ^Usecka;
     Ukaz = record
      case ii: byte of
       1:(ub: pBod;);
       2:(uk: pKruh;);
       3:(uu: pUsecka;);
     end;

var c     : Pohyb;
    cc    : char;
    Objekty: array [1..100] of Ukaz; { pole objekt }
    index : 1..100;     { poadov slo objektu v poli }
    i     : integer;

const oCo = 10;   { velikost posunu objektu }
      rr = 2;     { vzdlenost ar v rmeku }

const I1 = 'B: bod    K: kruznice   U: usecka   Q: konec';
      I2 = #24#25#26#27' posun   PgUp/PdDn zmena velikosti   O otoceni   Esc umisten';
      { text npovdy }

procedure Ramecek;     { rmeek grafick obrazovky }
 begin
  moveto(0,0);
  lineto(xx,0);
  lineto(xx,yy);
  lineto(0,yy);
  lineto(0,0);
  moveto (rr,rr);
  lineto(xx-rr,rr);
  lineto(xx-rr,yy-rr);
  lineto(rr,yy-rr);
  lineto(rr,rr);
 end;

procedure Obnova; { obnova rmeku a grafickch objekt }
begin             { pokozench pechodem jinho objektu }
 Ramecek;
  for i := 1 to index-1 do with Objekty[i] do begin
    case ii of
    1: ub^.Obnov;
    2: uk^.Obnov;
    3: uu^.Obnov;
    end;
  end;
  Instrukce(I1);  { zobrazen npovdy }
end;

begin
 SpustGrafiku(cesta);
 Ramecek;
 Instrukce(I1);
 c := Vlevo;
 index := 1;
 repeat    { interpretan cyklus pro vytven objekt }
  cc := readkey;
  if cc in ['b', 'B', 'u', 'U', 'k', 'K', 'Q', 'q'] then begin
    Instrukce(I2);
    case cc of
     'b', 'B':  { Bod }
       begin
        Objekty[index].ub := new(pBod, Udelej(xx div 2, yy div 2));
        Objekty[index].ii := 1;
        Objekty[index].ub^.Nakresli;
        Objekty[index].ub^.UsadSe(oCo);
        inc(index);
       end;
     'k','K':    { Krunice }
       begin
        Objekty[index].uk := new(pKruh, Udelej(xx div 2, yy div 2, 50));
        Objekty[index].ii := 2;
        Objekty[index].uk^.Nakresli;
        Objekty[index].uk^.UsadSe(oCo);
        inc(index);
       end;
     'u','U':    { seka }
       begin
        Objekty[index].uu := new(pUsecka, Udelej(xx div 2, yy div 2));
        Objekty[index].ii:= 3;
        Objekty[index].uu^.Nakresli;
        Objekty[index].uu^.UsadSe(oCo);
        inc(index);
       end;
      'q','Q':  c := Konec;  { Konec programu }
    end;
    if (c <> Konec) then Obnova;
  end;
 until c = Konec;
 for i := 1 to index-1 do with Objekty[i] do begin
    if (ub <> nil) then Dispose(ub, Zrus) else
      if (uk <> nil) then Dispose(uk, Zrus) else
      if (uu <> nil) then Dispose(uu, Zrus);
 end;
 UkonciGrafiku;
end.